Package com.typesafe.config.impl

# Class Parseable

java.lang.Object
com.typesafe.config.impl.Parseable

All Implemented Interfaces:
  `ConfigParseable`

public abstract class Parseable extends Object implements ConfigParseable
Internal implementation detail, not ABI stable, do not touch. For use only by the `com.typesafe.config` package. The point of this class is to avoid "propagating" each overload on "thing which can be parsed" through multiple interfaces. Most interfaces can have just one overload that takes a Parseable. Also it's used as an abstract "resource handle" in the ConfigIncluder interface.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected static interface`
`Parseable.Relativizer`
Internal implementation detail, not ABI stable, do not touch.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Parseable()`

## Method Summary

Modifier and Type
Method
Description
`protected abstract ConfigOrigin`
`createOrigin()`
`static Parseable`
`newFile(File input, ConfigParseOptions options)`
`static Parseable`
`newNotFound(String whatNotFound, String message, ConfigParseOptions options)`
`static Parseable`
`newProperties(Properties properties, ConfigParseOptions options)`
`static Parseable`
`newReader(Reader reader, ConfigParseOptions options)`
`static Parseable`
`newResources(Class<?> klass, String resource, ConfigParseOptions options)`
`static Parseable`
`newResources(String resource, ConfigParseOptions options)`
`static Parseable`
`newString(String input, ConfigParseOptions options)`
`static Parseable`
`newURL(URL input, ConfigParseOptions options)`
`ConfigParseOptions`
`options()`
Get the initial options, which can be modified then passed to parse().
`final ConfigOrigin`
`origin()`
Returns a `ConfigOrigin` describing the origin of the parseable item.
`ConfigObject`
`parse()`
`ConfigObject`
`parse(ConfigParseOptions baseOptions)`
Parse whatever it is.
`ConfigDocument`
`parseConfigDocument()`
`protected void`
`postConstruct(ConfigParseOptions baseOptions)`
`protected ConfigDocument`
`rawParseDocument(ConfigOrigin origin, ConfigParseOptions finalOptions)`
`protected com.typesafe.config.impl.AbstractConfigValue`
`rawParseValue(ConfigOrigin origin, ConfigParseOptions finalOptions)`
`protected abstract Reader`
`reader()`
`protected Reader`
`reader(ConfigParseOptions options)`
`String`
`toString()`
`protected static void`
`trace(String message)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Parseable

protected Parseable()

## Method Details

### postConstruct

protected void postConstruct(ConfigParseOptions baseOptions)

### reader

protected abstract Reader reader() throws IOException

Throws:
  `IOException`

### reader

protected Reader reader(ConfigParseOptions options) throws IOException

Throws:
  `IOException`

### trace

protected static void trace(String message)

### parse

public ConfigObject parse(ConfigParseOptions baseOptions)
Description copied from interface: `ConfigParseable`
Parse whatever it is. The options should come from `options()` but you could tweak them if you like.

Specified by:
  `parse` in interface `ConfigParseable`
Parameters:
  `baseOptions` - parse options, should be based on the ones from `options()`
Returns:
  the parsed object

### rawParseValue

protected com.typesafe.config.impl.AbstractConfigValue rawParseValue(ConfigOrigin origin, ConfigParseOptions finalOptions) throws IOException

Throws:
  `IOException`

### rawParseDocument

protected ConfigDocument rawParseDocument(ConfigOrigin origin, ConfigParseOptions finalOptions) throws IOException

Throws:
  `IOException`

### parse

public ConfigObject parse()

### parseConfigDocument

public ConfigDocument parseConfigDocument()

### origin

public final ConfigOrigin origin()
Description copied from interface: `ConfigParseable`
Returns a `ConfigOrigin` describing the origin of the parseable item.

Specified by:
  `origin` in interface `ConfigParseable`
Returns:
  the origin of the parseable item

### createOrigin

protected abstract ConfigOrigin createOrigin()

### options

public ConfigParseOptions options()
Description copied from interface: `ConfigParseable`
Get the initial options, which can be modified then passed to parse(). These options will have the right description, includer, and other parameters already set up.

Specified by:
  `options` in interface `ConfigParseable`
Returns:
  the initial options

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### newNotFound

public static Parseable newNotFound(String whatNotFound, String message, ConfigParseOptions options)

### newReader

public static Parseable newReader(Reader reader, ConfigParseOptions options)

### newString

public static Parseable newString(String input, ConfigParseOptions options)

### newURL

public static Parseable newURL(URL input, ConfigParseOptions options)

### newFile

public static Parseable newFile(File input, ConfigParseOptions options)

### newResources

public static Parseable newResources(Class<?> klass, String resource, ConfigParseOptions options)

### newResources

public static Parseable newResources(String resource, ConfigParseOptions options)

### newProperties

public static Parseable newProperties(Properties properties, ConfigParseOptions options)